zipios::BasicEntry Class Reference

BasicEntry is a FileEntry that is suitable as a base class for basic entries, that e.g. More...

`#include <basicentry.h>`

Inheritance diagram for zipios::BasicEntry:
[legend]

## Public Member Functions

| BasicEntry (const string &filename, const string &comment, const FilePath &basepath=FilePath())
| Constructor.
virtual string | getComment () const
| Returns the comment of the entry, if it has one.
virtual uint32 | getCompressedSize () const
| Returns the compressed size of the entry.
virtual uint32 | getCrc () const
| Returns the Crc for the entry, if it has one.
virtual vector< unsigned char > | getExtra () const
| Returns a vector of bytes of extra data that may be stored with the entry.
virtual StorageMethod | getMethod () const
| Returns the method used to store the entry in the FileCollection.
virtual string | getName () const
| Returns the full filename of the entry, including a path if the entry is stored in a subfolder.
virtual string | getFileName () const
| Returns the filename of the entry.
virtual uint32 | getSize () const
| Returns the (uncompressed) size of the entry data.
virtual int | getTime () const
| Returns the date and time of FIXME: what?
virtual bool | isValid () const
| Any method or operator that initializes a FileEntry may set a flag, that specifies whether the read entry is valid or not.
virtual bool | isDirectory () const
| Returns true if the entry is a directory.
virtual void | setComment (const string &comment)
| Sets the comment field for the FileEntry.
virtual void | setCompressedSize (uint32 size)
| Set the compressed size field of the entry.
virtual void | setCrc (uint32 crc)
| Sets the crc field.
virtual void | setExtra (const vector< unsigned char > &extra)
| Sets the extra field.
virtual void | setMethod (StorageMethod method)
| Sets the storage method field for the entry.
virtual void | setName (const string &name)
| Sets the name field for the entry.
virtual void | setSize (uint32 size)
| Sets the size field for the entry.
virtual void | setTime (int time)
| Sets the time field for the entry.
virtual string | toString () const
| Returns a human-readable string representation of the entry.
virtual FileEntry * | clone () const
| Create a heap allocated clone of the object this method is called for.
Public Member Functions inherited from zipios::FileEntry
virtual | ~FileEntry ()
| FileEntry destructor.

## Protected Attributes

string | _filename
string | _comment
int | _size
bool | _valid
FilePath | _basepath
Protected Attributes inherited from zipios::FileEntry
ReferenceCount< FileEntry > | _refcount

## Additional Inherited Members

Protected Member Functions inherited from zipios::FileEntry
void | ref () const
unsigned int | unref () const

## Detailed Description

BasicEntry is a FileEntry that is suitable as a base class for basic entries, that e.g.

do not support any form of compression

Definition at line 18 of file basicentry.h.

## Constructor & Destructor Documentation

## BasicEntry()

zipios::BasicEntry::BasicEntry | ( | const string & | filename,
|  | const string & | comment,
|  | const FilePath & | basepath = FilePath() )

explicit

Constructor.

Parameters

  filename | the filename of the entry.
  comment | a comment for the entry.

Definition at line 24 of file basicentry.cpp.

## ~BasicEntry()

zipios::BasicEntry::~BasicEntry | ( |  | ) |

virtual

Definition at line 136 of file basicentry.cpp.

## Member Function Documentation

## clone()

FileEntry * zipios::BasicEntry::clone | ( |  | ) | const

virtual

Create a heap allocated clone of the object this method is called for.

The caller is responsible for deallocating the clone when he is done with it.

Returns
  A heap allocated copy of the object this method is called for.

Implements zipios::FileEntry.

Definition at line 132 of file basicentry.cpp.

## getComment()

string zipios::BasicEntry::getComment | ( |  | ) | const

virtual

Returns the comment of the entry, if it has one.

Otherwise it returns an empty string.

Returns
  the comment associated with the entry, if there is one.

Implements zipios::FileEntry.

Definition at line 42 of file basicentry.cpp.

## getCompressedSize()

uint32 zipios::BasicEntry::getCompressedSize | ( |  | ) | const

virtual

Returns the compressed size of the entry.

If the entry is not stored in a compressed format, the uncompressed size is returned.

Returns
  the compressed size of the entry. If the entry is stored without compression the uncompressed size is returned.

Implements zipios::FileEntry.

Definition at line 46 of file basicentry.cpp.

## getCrc()

uint32 zipios::BasicEntry::getCrc | ( |  | ) | const

virtual

Returns the Crc for the entry, if it has one.

FIXME: what is returned if it doesn't have one?

Returns
  the Crc for the entry, if it has one.

Implements zipios::FileEntry.

Definition at line 50 of file basicentry.cpp.

## getExtra()

vector< unsigned char > zipios::BasicEntry::getExtra | ( |  | ) | const

virtual

Returns a vector of bytes of extra data that may be stored with the entry.

Returns
  A vector< unsigned char > of extra bytes that may potentially be associated with an entry.

Implements zipios::FileEntry.

Definition at line 54 of file basicentry.cpp.

## getFileName()

string zipios::BasicEntry::getFileName | ( |  | ) | const

virtual

Returns the filename of the entry.

Returns
  Returns the filename of the entry.

Implements zipios::FileEntry.

Definition at line 66 of file basicentry.cpp.

## getMethod()

StorageMethod zipios::BasicEntry::getMethod | ( |  | ) | const

virtual

Returns the method used to store the entry in the FileCollection.

Returns
  the storage method used to store the entry in the collection.

See also
  StorageMethod.

Implements zipios::FileEntry.

Definition at line 58 of file basicentry.cpp.

## getName()

string zipios::BasicEntry::getName | ( |  | ) | const

virtual

Returns the full filename of the entry, including a path if the entry is stored in a subfolder.

Returns
  the filename of the entry, including path if the entry is stored in a sub-folder.

Implements zipios::FileEntry.

Definition at line 62 of file basicentry.cpp.

## getSize()

uint32 zipios::BasicEntry::getSize | ( |  | ) | const

virtual

Returns the (uncompressed) size of the entry data.

Returns
  Returns the (uncompressed) size of the entry.

Implements zipios::FileEntry.

Definition at line 79 of file basicentry.cpp.

## getTime()

int zipios::BasicEntry::getTime | ( |  | ) | const

virtual

Returns the date and time of FIXME: what?

Returns
  the date and time of the entry.

Implements zipios::FileEntry.

Definition at line 83 of file basicentry.cpp.

## isDirectory()

bool zipios::BasicEntry::isDirectory | ( |  | ) | const

virtual

Returns true if the entry is a directory.

A directory entry is an entry which name ends with a separator ('/' for Unix systems, '\' for Windows and DOS systems.

Returns
  true if the entry is a directory.

Implements zipios::FileEntry.

Definition at line 92 of file basicentry.cpp.

## isValid()

bool zipios::BasicEntry::isValid | ( |  | ) | const

virtual

Any method or operator that initializes a FileEntry may set a flag, that specifies whether the read entry is valid or not.

If it isn't this method returns false.

Returns
  true if the FileEntry has been parsed succesfully.

Implements zipios::FileEntry.

Definition at line 87 of file basicentry.cpp.

## setComment()

void zipios::BasicEntry::setComment | ( | const string & | comment | ) |

virtual

Sets the comment field for the FileEntry.

Parameters

  comment | string with the new comment.

Implements zipios::FileEntry.

Definition at line 98 of file basicentry.cpp.

## setCompressedSize()

void zipios::BasicEntry::setCompressedSize | ( | uint32 | size | ) |

virtual

Set the compressed size field of the entry.

Parameters

  size | value to set the compressed size field of the entry to.

Implements zipios::FileEntry.

Definition at line 102 of file basicentry.cpp.

## setCrc()

void zipios::BasicEntry::setCrc | ( | uint32 | crc | ) |

virtual

Sets the crc field.

Parameters

  crc | value to set the crc field to.

Implements zipios::FileEntry.

Definition at line 105 of file basicentry.cpp.

## setExtra()

void zipios::BasicEntry::setExtra | ( | const vector< unsigned char > & | extra | ) |

virtual

Sets the extra field.

Parameters

  extra | the extra field is set to this value.

Implements zipios::FileEntry.

Definition at line 108 of file basicentry.cpp.

## setMethod()

void zipios::BasicEntry::setMethod | ( | StorageMethod | method | ) |

virtual

Sets the storage method field for the entry.

Parameters

  method | the method field is set to the specified value.

Implements zipios::FileEntry.

Definition at line 111 of file basicentry.cpp.

## setName()

void zipios::BasicEntry::setName | ( | const string & | name | ) |

virtual

Sets the name field for the entry.

Parameters

  name | the name field is set to the specified value.

Implements zipios::FileEntry.

Definition at line 114 of file basicentry.cpp.

## setSize()

void zipios::BasicEntry::setSize | ( | uint32 | size | ) |

virtual

Sets the size field for the entry.

Parameters

  size | the size field is set to this value.

Implements zipios::FileEntry.

Definition at line 118 of file basicentry.cpp.

## setTime()

void zipios::BasicEntry::setTime | ( | int | time | ) |

virtual

Sets the time field for the entry.

Parameters

  time | the time field is set to the specified value.

Implements zipios::FileEntry.

Definition at line 122 of file basicentry.cpp.

## toString()

string zipios::BasicEntry::toString | ( |  | ) | const

virtual

Returns a human-readable string representation of the entry.

Returns
  a human-readable string representation of the entry.

Implements zipios::FileEntry.

Definition at line 126 of file basicentry.cpp.

## Member Data Documentation

## _basepath

FilePath zipios::BasicEntry::_basepath

protected

Definition at line 59 of file basicentry.h.

## _comment

string zipios::BasicEntry::_comment

protected

Definition at line 56 of file basicentry.h.

## _filename

string zipios::BasicEntry::_filename

protected

Definition at line 55 of file basicentry.h.

## _size

int zipios::BasicEntry::_size

protected

Definition at line 57 of file basicentry.h.

## _valid

bool zipios::BasicEntry::_valid

protected

Definition at line 58 of file basicentry.h.

The documentation for this class was generated from the following files:

- basicentry.h
- basicentry.cpp